import processing.core.*; import processing.xml.*; import java.applet.*; import java.awt.*; import java.awt.image.*; import java.awt.event.*; import java.io.*; import java.net.*; import java.text.*; import java.util.*; import java.util.zip.*; import javax.sound.midi.*; import javax.sound.midi.spi.*; import javax.sound.sampled.*; import javax.sound.sampled.spi.*; import java.util.regex.*; import javax.xml.parsers.*; import javax.xml.transform.*; import javax.xml.transform.dom.*; import javax.xml.transform.sax.*; import javax.xml.transform.stream.*; import org.xml.sax.*; import org.xml.sax.ext.*; import org.xml.sax.helpers.*; public class newsClockSlim extends PApplet {//                
//  NEWS CLOCK  
//        




String rss_url[];
PImage am, pm, clock, titolo, legenda;
XMLElement rss0, rss1, rss2, rss3, rss4;
String[] title0, title1, title2, title3, title4;
String[] pubDate0, pubDate1, pubDate2, pubDate3, pubDate4;
int color0;
int color1;
int color2;
int color3;
int color4;
int num_news;
PFont font;


public void setup(){
  size(900, 600);
  smooth();
  background(255);
  num_news = 10;
  setupSlide();
  font = loadFont("helvetica10.vlw"); 
  textFont(font);   

  rss_url = new String[5];
  
  // REPUBBLICA.IT
  rss_url[0] = "http://rss.feedsportal.com/c/32275/f/438646/index.rss"; // calcio
  rss_url[1] = "http://rss.feedsportal.com/c/32275/f/438639/index.rss"; // economia
  rss_url[2] = "http://rss.feedsportal.com/c/32275/f/438642/index.rss"; // politica
  rss_url[3] = "http://rss.feedsportal.com/c/32275/f/438644/index.rss"; // cultura
  rss_url[4] = "http://www.repubblica.it/rss/rubriche/rss2.0.xml"; // persone
  
  // SPIGEL.DE
  /*
  rss_url[0] = "http://www.spiegel.de/sport/fussball/index.rss"; // calcio
  rss_url[1] = "http://www.spiegel.de/wirtschaft/index.rss"; // economia
  rss_url[2] = "http://www.spiegel.de/politik/index.rss"; // politica
  rss_url[3] = "http://www.spiegel.de/kultur/index.rss"; // cultura
  rss_url[4] = "http://www.spiegel.de/panorama/index.rss"; // persone
  */

  am = loadImage("am.png");
  pm = loadImage("pm.png");
  clock = loadImage("clock.png");
  titolo = loadImage("titolo.png");
  legenda = loadImage("legenda.png");

  rss0 = new XMLElement(this, rss_url[0]);
  rss1 = new XMLElement(this, rss_url[1]);
  rss2 = new XMLElement(this, rss_url[2]);
  rss3 = new XMLElement(this, rss_url[3]);
  rss4 = new XMLElement(this, rss_url[4]);
  
  color0 = 0xffb81a19;
  color1 = 0xffff9000;
  color2 = 0xffcbb11e;
  color3 = 0xff6eb444;
  color4 = 0xff212ede;
}

public void draw(){

  background(255);
  imageMode(CENTER);
  image(clock, 250-(clock.width/2), 250-(clock.height/2));
  image(clock, 650-(clock.width/2), 250-(clock.height/2));
  image(titolo, 35, 15);
  image(legenda, 0, 443);
  
  stroke(100,100,100, 35);
  line(40, 50, width-40, 50);
  line(40, 440, width-40, 440);
  
  scanFeed();
  stroke(100,100,100, 45);
  noFill();
  ellipse(250, 250, 100, 100);
  ellipse(250, 250, 150, 150);
  ellipse(250, 250, 200, 200);
  ellipse(250, 250, 250, 250);
  ellipse(250, 250, 300, 300);
  ellipse(650, 250, 100, 100);
  ellipse(650, 250, 150, 150);
  ellipse(650, 250, 200, 200);
  ellipse(650, 250, 250, 250);
  ellipse(650, 250, 300, 300);
  
  stroke(100,100,100, 45);
  fill(255, 255, 255);
  ellipse(250, 250, 50, 50);
  ellipse(650, 250, 50, 50);
  
  imageMode(CENTER);
  image(am, 250-(am.width/2), 250-(am.height/2));
  image(pm, 650-(pm.width/2), 250-(pm.height/2));
  
  drawSlide();
  fill(148,147,147);
  text(("news per category: "+num_news), 40, 90);
}




public void drawFeed(String[] title, String[] pubDate, int colore, int w){

  String description;
  String time;
  String meridiano;
  int minuti_totali;
  float delta;
  float posizione;
  float start;
  int x = 0;
  int y = 250;
  String[] words;
  int num_words;
  int alfa = 0;
  if(title.length < num_news) {
    num_news = title.length;
  }
  
  for(int i=0; i<num_news; i++){
    description = title[i];
    time = pubDate[i];

    // calcolo numero parole per news
    words = splitTokens(description);
    num_words = words.length;
    
    // orologio per ogni news
    time = time.substring(17, 25);
    int ora = PApplet.parseInt(time.substring(0,2))+2;
    int minuto = PApplet.parseInt(time.substring(3,5));
    if(minuto < 10){ minuto = 10; }
    if(ora >= 12){ meridiano = "PM"; ora = ora-12; } else { meridiano = "AM"; }
    posizione = ora+(minuto/60.0f);
    delta = 2*PI/12; // angolo che rappresenta un minuto
    start = posizione*delta;
    if(meridiano=="AM"){ x = 250; } else if(meridiano=="PM"){ x = 650; }
    
    if(num_words > 70){ alfa = 100; }
    if(num_words <= 70){ alfa = 90; }
    if(num_words <= 60){ alfa = 80; }
    if(num_words <= 50){ alfa = 70; }
    if(num_words <= 40){ alfa = 60; }
    if(num_words <= 30){ alfa = 50; }
    if(num_words <= 20){ alfa = 30; }
    if(num_words <= 10){ alfa = 20; }
    
    stroke(colore, alfa);
    fill(colore, alfa);
    start = start - PI/2; // 0\u00b0 = 12h
    arc(x, y, w, w, start, start+(delta/3));
    fill(0xffffffff);
    noStroke();
    ellipse(250, 250, w-50, w-50);
    ellipse(650, 250, w-50, w-50);
  }

}



public void scanFeed(){
  
  // SCAN FEED 4 : PERSONE
  // ------------------------------------------------------------------------------
  XMLElement[] titleXMLElements4 = rss4.getChildren("channel/item/description");
  XMLElement[] pubDateXMLElements4 = rss4.getChildren("channel/item/pubDate");
  title4 = new String[titleXMLElements4.length];
  pubDate4 = new String[pubDateXMLElements4.length];
  for (int i = 0; i < titleXMLElements4.length; i++) {
    title4[i] = titleXMLElements4[i].getContent(); 
    pubDate4[i] = pubDateXMLElements4[i].getContent(); 
  }
  drawFeed(title4, pubDate4, color4, 300);
  
  
  // SCAN FEED 3 : CULTURA
  // ------------------------------------------------------------------------------
  XMLElement[] titleXMLElements3 = rss3.getChildren("channel/item/description");
  XMLElement[] pubDateXMLElements3 = rss3.getChildren("channel/item/pubDate");
  title3 = new String[titleXMLElements3.length];
  pubDate3 = new String[pubDateXMLElements3.length];
  for (int i = 0; i < titleXMLElements3.length; i++) {
    title3[i] = titleXMLElements3[i].getContent(); 
    pubDate3[i] = pubDateXMLElements3[i].getContent(); 
  }
  drawFeed(title3, pubDate3, color3, 250);
  
  
  // SCAN FEED 2 : POLITICA
  // ------------------------------------------------------------------------------
  XMLElement[] titleXMLElements2 = rss2.getChildren("channel/item/description");
  XMLElement[] pubDateXMLElements2 = rss2.getChildren("channel/item/pubDate");
  title2 = new String[titleXMLElements2.length];
  pubDate2 = new String[pubDateXMLElements2.length];
  for (int i = 0; i < titleXMLElements2.length; i++) {
    title2[i] = titleXMLElements2[i].getContent(); 
    pubDate2[i] = pubDateXMLElements2[i].getContent(); 
  }
  drawFeed(title2, pubDate2, color2, 200);
  
  
  // SCAN FEED 1 : ECONOMIA
  // ------------------------------------------------------------------------------
  XMLElement[] titleXMLElements1 = rss1.getChildren("channel/item/description");
  XMLElement[] pubDateXMLElements1 = rss1.getChildren("channel/item/pubDate");
  title1 = new String[titleXMLElements1.length];
  pubDate1 = new String[pubDateXMLElements1.length];
  for (int i = 0; i < titleXMLElements1.length; i++) {
    title1[i] = titleXMLElements1[i].getContent(); 
    pubDate1[i] = pubDateXMLElements1[i].getContent(); 
  }
  drawFeed(title1, pubDate1, color1, 150);
  
  
  // SCAN FEED 0 : CALCIO
  // ------------------------------------------------------------------------------
  XMLElement[] titleXMLElements0 = rss0.getChildren("channel/item/description");
  XMLElement[] pubDateXMLElements0 = rss0.getChildren("channel/item/pubDate");
  title0 = new String[titleXMLElements0.length];
  pubDate0 = new String[pubDateXMLElements0.length];
  for (int i = 0; i < titleXMLElements0.length; i++) {
    title0[i] = titleXMLElements0[i].getContent(); 
    pubDate0[i] = pubDateXMLElements0[i].getContent(); 
  }
  drawFeed(title0, pubDate0, color0, 100);
  
}
Handle[] handles;
int num;

public void setupSlide()
{
  num = 1;
  handles = new Handle[num];
  int hsize = 10;
  for(int i=0; i<num; i++) {
    handles[i] = new Handle(40, 70+i*10, 20, 12, handles);
  }
}

public void drawSlide()
{
  for(int i=0; i<num; i++) {
    handles[i].update();
    handles[i].display();
  }
}

public void mouseReleased() 
{
  for(int i=0; i<num; i++) {
    handles[i].release();
  }
}

class Handle
{
  int x, y;
  int boxx, boxy;
  int length = 12;
  int size;
  boolean over;
  boolean press;
  boolean locked = false;
  boolean otherslocked = false;
  Handle[] others;
  
  Handle(int ix, int iy, int il, int is, Handle[] o)
  {
    x = ix;
    y = iy;
    length = il;
    size = is;
    boxx = x+length;
    boxy = y-6;
    boxy = y-6;
   
    
    others = o;
  }
  
  public void update() 
  {
    
    
    boxx = x+length;
    boxy = y;
    
    for(int i=0; i<others.length; i++) {
      if(others[i].locked == true) {
        otherslocked = true;
        break;
      } else {
        otherslocked = false;
      }  
    }
    
    if(otherslocked == false) {
      over();
      press();
    }
    
    if(press) {
      length = lock(mouseX-20, 1, 100);
      if(length <= 100){num_news = 10; }
      if(length <= 90){num_news = 9; }
      if(length <= 80){num_news = 8; }
      if(length <= 70){num_news = 7; }
      if(length <= 60){num_news = 6; }
      if(length <= 50){num_news = 5; }
      if(length <= 40){num_news = 4; }
      if(length <= 30){num_news = 3; }
      if(length <= 20){num_news = 2; }
      if(length <= 10){num_news = 1; }
    }
  }
  
  public void over()
  {
    if(overRect(boxx, boxy, 12, 12)) {
      over = true;
    } else {
      over = false;
    }
  }
  
  public void press()
  {
    if(over && mousePressed || locked) {
      press = true;
      locked = true;
    } else {
      press = false;
    }
  }
  
  public void release()
  {
    locked = false;
  }
  
  public void display() 
  {
   stroke(234);
    line(x, y, x+length, y);
    fill(234, 234, 234);
    stroke(234);
    rect(boxx, boxy-6, 12, 12);
    if(over || press) {
      stroke(190);
      line(boxx, boxy-6, boxx+12, boxy+6);
      line(boxx+12, boxy-6, boxx, boxy+6);
    }


  }
}

public boolean overRect(int x, int y, int width, int height) 
{
  if (mouseX >= x && mouseX <= x+width && mouseY >= y && mouseY <= y+height) {
    return true;
  } else {
    return false;
  }
}

public int lock(int val, int minv, int maxv) 
{ 
  return  min(max(val, minv), maxv); 
} 

  static public void main(String args[]) {     PApplet.main(new String[] { "newsClockSlim" });  }}