Handle[] handles;
int num;

void setupSlide()
{
  num = 1;
  handles = new Handle[num];
  int hsize = 10;
  for(int i=0; i<num; i++) {
    handles[i] = new Handle(40, 70+i*10, 20, 12, handles);
  }
}

void drawSlide()
{
  for(int i=0; i<num; i++) {
    handles[i].update();
    handles[i].display();
  }
}

void mouseReleased() 
{
  for(int i=0; i<num; i++) {
    handles[i].release();
  }
}

class Handle
{
  int x, y;
  int boxx, boxy;
  int length = 12;
  int size;
  boolean over;
  boolean press;
  boolean locked = false;
  boolean otherslocked = false;
  Handle[] others;
  
  Handle(int ix, int iy, int il, int is, Handle[] o)
  {
    x = ix;
    y = iy;
    length = il;
    size = is;
    boxx = x+length;
    boxy = y-6;
    boxy = y-6;
   
    
    others = o;
  }
  
  void update() 
  {
    
    
    boxx = x+length;
    boxy = y;
    
    for(int i=0; i<others.length; i++) {
      if(others[i].locked == true) {
        otherslocked = true;
        break;
      } else {
        otherslocked = false;
      }  
    }
    
    if(otherslocked == false) {
      over();
      press();
    }
    
    if(press) {
      length = lock(mouseX-20, 1, 100);
      if(length <= 100){num_news = 10; }
      if(length <= 90){num_news = 9; }
      if(length <= 80){num_news = 8; }
      if(length <= 70){num_news = 7; }
      if(length <= 60){num_news = 6; }
      if(length <= 50){num_news = 5; }
      if(length <= 40){num_news = 4; }
      if(length <= 30){num_news = 3; }
      if(length <= 20){num_news = 2; }
      if(length <= 10){num_news = 1; }
    }
  }
  
  void over()
  {
    if(overRect(boxx, boxy, 12, 12)) {
      over = true;
    } else {
      over = false;
    }
  }
  
  void press()
  {
    if(over && mousePressed || locked) {
      press = true;
      locked = true;
    } else {
      press = false;
    }
  }
  
  void release()
  {
    locked = false;
  }
  
  void display() 
  {
   stroke(234);
    line(x, y, x+length, y);
    fill(234, 234, 234);
    stroke(234);
    rect(boxx, boxy-6, 12, 12);
    if(over || press) {
      stroke(190);
      line(boxx, boxy-6, boxx+12, boxy+6);
      line(boxx+12, boxy-6, boxx, boxy+6);
    }


  }
}

boolean overRect(int x, int y, int width, int height) 
{
  if (mouseX >= x && mouseX <= x+width && mouseY >= y && mouseY <= y+height) {
    return true;
  } else {
    return false;
  }
}

int lock(int val, int minv, int maxv) 
{ 
  return  min(max(val, minv), maxv); 
} 

